import { reactive as z, computed as D, readonly as F, openBlock as d, createElementBlock as h, createElementVNode as c, defineComponent as E, ref as L, onMounted as P, onUnmounted as W, normalizeClass as N, renderSlot as _, normalizeProps as m, guardReactiveProps as v, mergeProps as Z, createBlock as M, resolveDynamicComponent as A, createCommentVNode as V, toDisplayString as S, withModifiers as G, createVNode as H, normalizeStyle as I, Teleport as K, unref as j, TransitionGroup as R, withCtx as w, Fragment as X, renderList as q } from "vue";
const U = {
  theme: {
    zIndex: 9999,
    top: "0",
    bottom: "auto",
    left: "0",
    right: "auto",
    iconSize: "40px",
    successColor: "#2bde3f",
    warnColor: "#ffc007",
    infoColor: "#1d72f3",
    errorColor: "#de0909",
    gray: "#aaaaaa",
    toasterMaxWidth: "500px",
    animationDuration: 1e3,
    animationFunction: "ease-in-out",
    translateX: "200px",
    direction: 1,
    toastBackgroundColor: "#ffff"
  },
  closable: !0,
  pauseOnHover: !0,
  closeOnDoubleClick: !0,
  duration: 10
};
function J() {
  return Math.random().toString(36).substring(2, 9);
}
function Q() {
  return {
    id: J(),
    type: "info",
    title: "info",
    text: "this is your info",
    options: U
  };
}
function Y(e) {
  const n = {};
  for (const t in e)
    n[`--${t}`] = e[t];
  return n;
}
function O(e = {}, n = {}) {
  const t = B(e), s = B(n);
  for (const i in t)
    t && typeof t[i] == "object" && t.hasOwnProperty(i) && !Array.isArray(t[i]) && (t[i] = Object.assign({}, t[i], s[i]), delete s[i]);
  return Object.assign(t, s);
}
function B(e) {
  const n = {};
  if (typeof e != "object")
    return e;
  for (const t in e)
    e[t] != null && (n[t] = B(e[t]));
  return n;
}
const k = {
  interfaces: {
    link: "https://github.com/hackcharms/vue3-toaster#interfaces",
    Toaster: "https://github.com/hackcharms/vue3-toaster#interfaces",
    ToastVariant: "https://github.com/hackcharms/vue3-toaster#interfaces"
  },
  howToUse: {
    link: "https://github.com/hackcharms/vue3-toaster#how-to-use"
  },
  methods: {
    link: "https://github.com/hackcharms/vue3-toaster#methods",
    success: "https://github.com/hackcharms/vue3-toaster#success",
    warn: "https://github.com/hackcharms/vue3-toaster#warn",
    info: "https://github.com/hackcharms/vue3-toaster#info",
    error: "https://github.com/hackcharms/vue3-toaster#error"
  },
  slots: {
    link: "https://github.com/hackcharms/vue3-toaster#slots"
  },
  events: {
    link: "https://github.com/hackcharms/vue3-toaster#events"
  }
};
function tt(e, n) {
  const t = Q();
  e.options = O(n, e.options);
  let s = O(t, e);
  return ["error", "info", "success", "warn"].includes(
    s == null ? void 0 : s.type
  ) || (console.warn(
    `"${s.type}" is not a valid type using default type info
        @see ${k.interfaces.ToastVariant} for "ToastVariant" interfaces
        `
  ), s.type = t.type), s.title || (s.title = s.type), s;
}
const y = z([]);
function x() {
  function e(o) {
    document.getElementById("ts__container") || console.warn(`ToastContainer component not found, please make sure you have added the component

      @see ${k.howToUse.link}
      `);
    const a = T().all, u = tt(
      Object.assign({}, o),
      a.value
    );
    return y.push(u), u.id;
  }
  function n({
    message: o = "info",
    type: a = "info"
  }) {
    var u, b;
    if (!["string", "object"].includes(typeof o)) {
      console.warn(
        `${a} function accept only typeof string or Object with "Toaster" interface
            @see ${k.interfaces.Toaster} for interfaces
            ${(u = k.methods) != null && u[a] ? "or @see " + ((b = k.methods) == null ? void 0 : b[a]) : ""}
            `
      );
      return;
    }
    return e(typeof o == "string" ? {
      type: a,
      text: o
    } : o);
  }
  function t(o) {
    return n({
      message: {
        type: "success",
        title: "Success",
        text: o
      }
    });
  }
  function s(o) {
    return n({
      message: {
        type: "info",
        title: "Information",
        text: o
      }
    });
  }
  function i(o) {
    return n({
      message: {
        type: "warn",
        title: "Warning",
        text: o
      }
    });
  }
  function f(o) {
    return n({
      message: {
        type: "error",
        title: "Error",
        text: o
      }
    });
  }
  function l(o) {
    let a = y.findIndex((u) => u.id === o);
    return a < 0 ? console.warn(`No active Toaster Found with Id "${o}"`) : (y.splice(a, 1), o);
  }
  function r(o) {
    return (!o || !(o != null && o.length)) && (o = y.map((a) => a.id)), o != null && o.length && o.forEach((a) => l(a)), o;
  }
  const C = D(() => y);
  return {
    add: e,
    success: t,
    warn: i,
    error: f,
    info: s,
    remove: l,
    clear: r,
    toasters: C
  };
}
const $ = z(
  Object.assign({}, U)
);
function T() {
  function e(t) {
    var s, i, f, l;
    return (s = t == null ? void 0 : t.theme) != null && s.bottom && ((i = t.theme) == null ? void 0 : i.bottom) !== "auto" && ($.theme.top = "auto"), (f = t == null ? void 0 : t.theme) != null && f.right && ((l = t.theme) == null ? void 0 : l.right) !== "auto" && ($.theme.left = "auto"), Object.assign($, O($, t)), n;
  }
  const n = D(() => $);
  return {
    update: e,
    all: n,
    cssVariables: F(Y(n.value.theme))
  };
}
const g = (e, n) => {
  const t = e.__vccOpts || e;
  for (const [s, i] of n)
    t[s] = i;
  return t;
}, et = {}, ot = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "24",
  height: "24",
  viewBox: "0 0 24 24",
  "stroke-width": "2",
  stroke: "currentColor",
  fill: "none",
  "stroke-linecap": "round",
  "stroke-linejoin": "round"
}, nt = /* @__PURE__ */ c("path", { d: "M12 12m-9 0a9 9 0 1 0 18 0a9 9 0 1 0 -18 0" }, null, -1), st = /* @__PURE__ */ c("path", { d: "M9 12l2 2l4 -4" }, null, -1), rt = [
  nt,
  st
];
function ct(e, n) {
  return d(), h("svg", ot, rt);
}
const it = /* @__PURE__ */ g(et, [["render", ct]]), at = {}, lt = {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 24 24",
  fill: "none"
}, ut = /* @__PURE__ */ c("path", {
  d: "M12 4a8 8 0 1 0 0 16 8 8 0 0 0 0-16zM2 12C2 6.477 6.477 2 12 2s10 4.477 10 10-4.477 10-10 10S2 17.523 2 12zm5.793-4.207a1 1 0 0 1 1.414 0L12 10.586l2.793-2.793a1 1 0 1 1 1.414 1.414L13.414 12l2.793 2.793a1 1 0 0 1-1.414 1.414L12 13.414l-2.793 2.793a1 1 0 0 1-1.414-1.414L10.586 12 7.793 9.207a1 1 0 0 1 0-1.414z",
  fill: "currentColor"
}, null, -1), dt = [
  ut
];
function ft(e, n) {
  return d(), h("svg", lt, dt);
}
const _t = /* @__PURE__ */ g(at, [["render", ft]]), ht = {}, pt = {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 12 12",
  fill: "none"
}, mt = /* @__PURE__ */ c("path", {
  d: "M5.25 8.25C5.25 7.83579 5.58579 7.5 6 7.5C6.41421 7.5 6.75 7.83579 6.75 8.25C6.75 8.66421 6.41421 9 6 9C5.58579 9 5.25 8.66421 5.25 8.25ZM5.50806 3.41012C5.55039 3.17688 5.75454 3 6 3C6.24546 3 6.44961 3.17688 6.49194 3.41012L6.5 3.5V6L6.49194 6.08988C6.44961 6.32312 6.24546 6.5 6 6.5C5.75454 6.5 5.55039 6.32312 5.50806 6.08988L5.5 6V3.5L5.50806 3.41012ZM11 6C11 8.76142 8.76142 11 6 11C3.23858 11 1 8.76142 1 6C1 3.23858 3.23858 1 6 1C8.76142 1 11 3.23858 11 6ZM10 6C10 3.79086 8.20914 2 6 2C3.79086 2 2 3.79086 2 6C2 8.20914 3.79086 10 6 10C8.20914 10 10 8.20914 10 6Z",
  fill: "currentColor"
}, null, -1), vt = [
  mt
];
function gt(e, n) {
  return d(), h("svg", pt, vt);
}
const Ct = /* @__PURE__ */ g(ht, [["render", gt]]), wt = {}, yt = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "24",
  height: "24",
  viewBox: "0 0 24 24",
  fill: "none",
  stroke: "currentColor",
  "stroke-width": "2",
  "stroke-linecap": "round",
  "stroke-linejoin": "round"
}, $t = /* @__PURE__ */ c("circle", {
  cx: "12",
  cy: "12",
  r: "10"
}, null, -1), kt = /* @__PURE__ */ c("line", {
  x1: "12",
  y1: "16",
  x2: "12",
  y2: "12"
}, null, -1), bt = /* @__PURE__ */ c("line", {
  x1: "12",
  y1: "8",
  x2: "12.01",
  y2: "8"
}, null, -1), xt = [
  $t,
  kt,
  bt
];
function Tt(e, n) {
  return d(), h("svg", yt, xt);
}
const Lt = /* @__PURE__ */ g(wt, [["render", Tt]]), Mt = {}, Ot = {
  width: "24",
  height: "24",
  viewBox: "0 0 24 24",
  fill: "none",
  xmlns: "http://www.w3.org/2000/svg"
}, Bt = /* @__PURE__ */ c("path", {
  d: "M6.2253 4.81108C5.83477 4.42056 5.20161 4.42056 4.81108 4.81108C4.42056 5.20161 4.42056 5.83477 4.81108 6.2253L10.5858 12L4.81114 17.7747C4.42062 18.1652 4.42062 18.7984 4.81114 19.1889C5.20167 19.5794 5.83483 19.5794 6.22535 19.1889L12 13.4142L17.7747 19.1889C18.1652 19.5794 18.7984 19.5794 19.1889 19.1889C19.5794 18.7984 19.5794 18.1652 19.1889 17.7747L13.4142 12L19.189 6.2253C19.5795 5.83477 19.5795 5.20161 19.189 4.81108C18.7985 4.42056 18.1653 4.42056 17.7748 4.81108L12 10.5858L6.2253 4.81108Z",
  fill: "currentColor"
}, null, -1), Dt = [
  Bt
];
function Vt(e, n) {
  return d(), h("svg", Ot, Dt);
}
const St = /* @__PURE__ */ g(Mt, [["render", Vt]]), jt = { class: "ts__toaster" }, zt = {
  class: /* @__PURE__ */ N(["ts__toast ts__content-center"])
}, Et = { class: "ts__content" }, Pt = { class: "ts__type ts__type-text" }, Nt = { class: "ts__message" }, Zt = ["onClick"], Ht = /* @__PURE__ */ E({
  __name: "Toast",
  props: {
    id: {},
    title: {},
    type: {},
    text: {},
    options: {}
  },
  setup(e) {
    const n = D(() => ({
      success: it,
      info: Lt,
      warn: Ct,
      error: _t
    })[r.type]), t = {
      onMouseover: i,
      onMouseleave: f,
      onDblclick: l
    };
    function s(p) {
      a.value = p;
    }
    function i() {
      r.options.pauseOnHover && s(!0);
    }
    function f() {
      r.options.pauseOnHover && s(!1);
    }
    function l() {
      r.options.closeOnDoubleClick && u();
    }
    const r = e, C = L(r.options.duration), o = L(0), a = L(!1);
    function u() {
      x().remove(r.id);
    }
    function b() {
      o.value = window.setInterval(() => {
        C.value <= 0 && u(), a.value || C.value--;
      }, 1e3);
    }
    return P(() => {
      b();
    }), W(() => {
      o.value && window.clearInterval(o.value);
    }), (p, At) => (d(), h("div", jt, [
      c("div", {
        class: N(`ts__${r.type}`)
      }, [
        c("div", zt, [
          _(p.$slots, "default", m(v({
            ...r,
            destroyToaster: u,
            pauseCountdown: s
          })), () => [
            c("div", Z({ class: "ts__content-center" }, t), [
              c("div", null, [
                _(p.$slots, "icon", m(v({ title: r.title, type: r.type })), () => [
                  n.value ? (d(), M(A(n.value), {
                    key: 0,
                    class: "ts__icon ts__icon-color"
                  })) : V("", !0)
                ], !0)
              ]),
              c("div", Et, [
                _(p.$slots, "content", m(v({
                  title: r.title,
                  text: r.text,
                  type: r.type
                })), () => [
                  c("p", Pt, S(r.title || r.type), 1),
                  c("p", Nt, S(r.text), 1)
                ], !0)
              ]),
              r.options.closable ? (d(), h("div", {
                key: 0,
                class: "ts__close ts__content-center",
                onClick: G(u, ["stop"])
              }, [
                _(p.$slots, "clearIcon", {}, () => [
                  H(St, { class: "ts__text-gray ts__close-icon" })
                ], !0)
              ], 8, Zt)) : V("", !0)
            ], 16)
          ], !0)
        ]),
        c("span", {
          class: "ts__bottom-progress-bar",
          style: I(`width: ${C.value / Number(r.options.duration) * 100}%`)
        }, null, 4)
      ], 2)
    ]));
  }
});
const It = /* @__PURE__ */ g(Ht, [["__scopeId", "data-v-85ea489e"]]), Ut = { class: "container" }, Ft = /* @__PURE__ */ E({
  __name: "ToastContainer",
  props: {
    pauseOnHover: { type: Boolean },
    closable: { type: Boolean },
    closeOnDoubleClick: { type: Boolean },
    duration: {},
    theme: {}
  },
  setup(e) {
    const n = x().toasters, t = e;
    return P(() => {
      Object.keys(t).length && T().update(t);
    }), (s, i) => (d(), M(K, { to: "body" }, [
      c("div", {
        class: "main-container",
        id: "ts__container",
        style: I(j(T)().cssVariables)
      }, [
        c("div", Ut, [
          H(R, {
            name: "ts__animation",
            tag: "div"
          }, {
            default: w(() => [
              (d(!0), h(X, null, q(j(n), (f) => (d(), M(It, Z({
                key: f.id
              }, f), {
                default: w((l) => [
                  _(s.$slots, "default", m(v(l)), void 0, !0)
                ]),
                content: w((l) => [
                  _(s.$slots, "content", m(v(l)), void 0, !0)
                ]),
                icon: w((l) => [
                  _(s.$slots, "icon", m(v(l)), void 0, !0)
                ]),
                clearIcon: w((l) => [
                  _(s.$slots, "clearIcon", m(v(l)), void 0, !0)
                ]),
                _: 2
              }, 1040))), 128))
            ]),
            _: 3
          })
        ])
      ], 4)
    ]));
  }
});
const Wt = /* @__PURE__ */ g(Ft, [["__scopeId", "data-v-069eec4c"]]), Kt = {
  install: (e, n) => {
    T().update(n), e.config.globalProperties.$toast = x(), e.component("ToastContainer", Wt), e.provide("$toast", x());
  }
};
export {
  Wt as ToastContainer,
  Kt as default,
  U as defaultConfig,
  x as useToaster,
  T as useToasterConfig
};
//# sourceMappingURL=index.es.js.map
